// -*- mode: js; js-indent-level: 4; indent-tabs-mode: nil -*-
/*
  Copyright (C) 2012-2019  Dieter Schärf <ds@dschaerf.de>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

const Lang = imports.lang;

const ExtensionUtils = imports.misc.extensionUtils;
const Main = imports.ui.main;

const Me = ExtensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience;

const KEY_SHOW_DASH = 'show-dash';

const Dash = new Lang.Class({
    Name: 'PanelManager.Dash',

    _init: function() {
        this._settingsChangedId = Convenience.Settings.connect('changed::'+KEY_SHOW_DASH, Lang.bind(this, this._onShowDash));
        this._onShowDash();
    },

    _onShowDash: function() {
        this._updateVisibility(Convenience.Settings.get_boolean(KEY_SHOW_DASH));
    },

    _updateVisibility: function(visible) {
        Main.overview._dash._container.visible = visible;
    },

    destroy: function() {
        Convenience.Settings.disconnect(this._settingsChangedId);
        this._updateVisibility(true);
    }
});

function getExtension() {
    return new Dash();
}
