// -*- mode: js; js-indent-level: 4; indent-tabs-mode: nil -*-
/*
  Copyright (C) 2012-2019  Dieter Schärf <ds@dschaerf.de>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

const ExtensionUtils = imports.misc.extensionUtils;

const Me = ExtensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience;

const PANELMANAGER_EXTENSIONS = [
    'showDesktop',
    'favorites',
    'places',
    'applications',
    'activities',
    'dateMenu',
    'recycleBin',
    'accessibility',
    'keyboard',
    'systemMenu',
    'dropDownArrow',
    'hotCorners',
    'dash'
];

function _getExtension(extension) {
    //try { return Me.imports[extension].getExtension(); } catch(e) { return null; }
return Me.imports[extension].getExtension();
}

function init(metadata) {
    Convenience.initTranslations();
}

let _panelManager = [];

function enable() {
    PANELMANAGER_EXTENSIONS.forEach(function(extension) {
        _panelManager.push(_getExtension(extension));
    });
    //  NOTE: Activate the next line for testing purposes only
    imports.ui.main.panelManager = _panelManager;
}

function disable() {
    while (_panelManager.length > 0) {
        let extension = _panelManager.pop();
        if (extension !== null) extension.destroy();
    }
}
